
WIDTH = 36;
HEIGHT = 36;

figure('Name','my Sudoku',...
      'Position',[200 200 420 420],...
      'Tag','my Sudoku',...
      'NumberTitle','off',...
      'Menubar','none',...
      'Color',[.9 .9 .9]);   
  
  axes('Units','pixels',...
      'PlotBoxAspectRatio',[1 1 1],...
      'Position',[WIDTH,HEIGHT,9*WIDTH,9*HEIGHT],...
      'Color','none',...
      'Box','on', ...
      'YDir','reverse', ... 
      'XLim',[0 9*WIDTH],...
      'YLim',[0 9*HEIGHT], ...
      'XColor','k','YColor','k','LineWidth',2,...  
      'Tag','mainaxes', ...
      'Xtick',[],'Ytick',[]);

   line([0 ; 9*WIDTH]*ones(1,8), [HEIGHT; HEIGHT]*[1:8],...
       'Color','k','LineWidth',1);
   line([0 ; 9*WIDTH]*[1 1], [HEIGHT; HEIGHT]*[3 6],...
       'Color','k','LineWidth',2);
   line([WIDTH; WIDTH]*[1:8],[0 ; 9*HEIGHT]*ones(1,8),...
       'Color','k','LineWidth',1);
   line([WIDTH; WIDTH]*[3 6],[0 ; 9*HEIGHT]*[1 1],...
       'Color','k','LineWidth',2);

%------------------------------------

S = [1 2 3 ; 4 5 6 ; 7 8 9];          % Use a group theoretic approach        
C = [7 8 9 1 2 3 4 5 6];              % to generate Sudoku matrices.
R = [3 1 2 6 4 5 9 7 8];              % Not all Sudoku matrices 
P = [1 2 3 4 5 6 7 8 9];              % can be generated in this way,
if rand < .5                          % but it's a quite large number.
P(1) = 2; P(2) = 1;
    if rand < .5, P(3) = 6; P(6) = 3; end
    if rand < .5, P(8) = 9; P(9) = 8; end
    if rand < .5, P(4) = 7; P(7) = 4; end
else      
    P(1) = 4; P(4) = 1;
    if rand < .5, P(9) = 6; P(6) = 9; end
    if rand < .5, P(8) = 7; P(7) = 8; end
    if rand < .5, P(2) = 5; P(5) = 2; end
end      
C = P(C(P));
R = P(R(P));
sol = [S C(S) C(C(S))];
sol = [sol ; R(sol) ; R(R(sol))];
sol = sol([randperm(3) randperm(3)+3 randperm(3)+6], ...
          [randperm(3) randperm(3)+3 randperm(3)+6]);
per = randperm(9);
sol = per(sol);

 field = zeros(9,9);
   h = zeros(9,9);                          % button handles
   for i = 1:9
       for j = 1:9
           h(i,j) = text((i-1)*WIDTH+OFFSET,(j-1)*HEIGHT+OFFSET,'  ', ...
            'FontSize',18, ...
            'HorizontalAlignment','center', ...
            'Units','pixels',...
            'UserData',[i,j]);              % stuff i,j into UserData
       end
   end
  
   
